diff -ruN freeswan-1.9.orig/pluto/spdb.c freeswan-1.9/pluto/spdb.c
--- freeswan-1.9.orig/pluto/spdb.c	Mon Feb 26 13:42:57 2001
+++ freeswan-1.9/pluto/spdb.c	Thu May 17 11:31:23 2001
@@ -648,6 +1209,180 @@
     return val;
 }
 
+#ifdef OPENSSL
+struct _trans_node {
+  struct oakley_trans_attrs ta;
+  struct isakmp_transform trans;
+  u_char *attr_start;
+  size_t attr_len;
+  bool elim; /* has this node been eliminated from the selection process */
+  struct _trans_node *next;
+};
+
+typedef struct _trans_node *trans_list;
+
+/* Free a list of Oakley transforms */
+static void
+trans_list_free( trans_list *l )
+{
+  trans_list p;
+
+  if (!l) return;
+  while (*l) {
+    p = *l;
+    *l = p->next;
+    pfree(p->attr_start);
+    pfree(p);
+  }
+}
+
+static void
+trans_list_append(trans_list *l,
+		  struct oakley_trans_attrs *ta,
+		  struct isakmp_transform *trans,
+		  u_char *attr_start,
+		  size_t attr_len) {
+  trans_list p, pp;
+
+  if (!l) return;
+  if ((p = alloc_bytes(sizeof(struct _trans_node),
+		       "transformation node")) == NULL) return;
+  p->ta = *ta;
+  p->trans = *trans;
+  p->attr_len = attr_len;
+  if ((p->attr_start = alloc_bytes(attr_len, "attribute")) == NULL) {
+    pfree(p);
+    return;
+  }
+  memcpy(p->attr_start, attr_start, attr_len);
+  p->elim = FALSE;
+  p->next = NULL;
+  if (*l == NULL) {
+    *l = p;
+  } else {
+    for(pp = *l; pp->next ; pp = pp->next);
+    pp->next = p;
+  }
+}
+
+static bool
+select_trans_candidate(trans_list l,
+		       struct oakley_trans_attrs *ta,
+		       struct isakmp_transform *trans,
+		       u_char **attr_start,
+		       size_t *attr_len,
+		       u_int32_t opts)
+{
+  bool ret = FALSE;
+  trans_list auth[OAKLEY_ELGAMAL_ENC_REV+1], p;
+  uint i, numprefs, pref[10];
+
+  if (!l) {
+    DBG(DBG_PARSING,
+    DBG_log("No candidate transforms to choose from");
+    );
+    return FALSE;
+  }
+
+  if ((!ta) || (!attr_len) || (!trans) || (!attr_start)) {
+    DBG(DBG_PARSING,
+    DBG_log("No space to store selected transform");
+    );
+    return FALSE;
+  }
+
+  /* Separate all elements of the list by authentication method */
+
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_ELGAMAL_ENC_REV; i++)
+    auth[i] = NULL;
+  for(p=l; p; p=p->next)
+    if ((p->ta.auth >= OAKLEY_PRESHARED_KEY) &&
+	(p->ta.auth <= OAKLEY_ELGAMAL_ENC_REV )) {
+      trans_list_append(&(auth[p->ta.auth]),
+			&(p->ta),
+			&(p->trans),
+			p->attr_start,
+			p->attr_len);
+    }
+
+  numprefs = 7;
+  pref[numprefs-1] = OAKLEY_PRESHARED_KEY;
+  DBG(DBG_PARSING | DBG_CRYPT,
+  DBG_log("select_trans_candidate: %08x", opts);
+  );
+  if (opts & CERT_OPTION_PK) {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring revised PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[1] = OAKLEY_RSA_ENC_REV;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring standard PK encryption schemes");
+      );
+      pref[0] = OAKLEY_ELGAMAL_ENC;
+      pref[1] = OAKLEY_RSA_ENC;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_RSA_SIG;
+      pref[5] = OAKLEY_DSS_SIG;
+    }
+  } else {
+    if (opts & CERT_OPTION_REV) {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then revised pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[3] = OAKLEY_RSA_ENC_REV;
+      pref[4] = OAKLEY_ELGAMAL_ENC;
+      pref[5] = OAKLEY_RSA_ENC;
+    } else {
+      DBG(DBG_PARSING | DBG_CRYPT,
+      DBG_log("Preferring digisig schemes, then standard pk");
+      );
+      pref[0] = OAKLEY_RSA_SIG;
+      pref[1] = OAKLEY_DSS_SIG;
+      pref[2] = OAKLEY_ELGAMAL_ENC;
+      pref[3] = OAKLEY_RSA_ENC;
+      pref[4] = OAKLEY_ELGAMAL_ENC_REV;
+      pref[5] = OAKLEY_RSA_ENC_REV;
+    }
+  }
+
+  for(i=0; ((i<numprefs) && (!ret)); i++) {
+    DBG(DBG_PARSING,
+    DBG_log("Trying out: %s", enum_show(&oakley_auth_names, pref[i]));
+    );
+    if ((pref[i]) && (auth[pref[i]])) {
+      ret = TRUE;
+      *ta = auth[pref[i]]->ta;
+      *trans = auth[pref[i]]->trans;
+      *attr_start = alloc_bytes(auth[pref[i]]->attr_len, "attribute");
+      if (*attr_start) {
+	*attr_len = auth[pref[i]]->attr_len;
+	memcpy(*attr_start, auth[pref[i]]->attr_start, *attr_len);
+      }
+      DBG(DBG_PARSING,
+      DBG_log("Candidate selected: %s", 
+        enum_show(&oakley_auth_names, pref[i]));
+      );
+    }
+}
+  
+  for(i=OAKLEY_PRESHARED_KEY; i<=OAKLEY_RSA_ENC_REV; i++) {
+    trans_list_free(&auth[i]);
+  }
+  return ret;
+}
+#endif
+
 /* Parse the body of an ISAKMP SA Payload (i.e. Phase 1 / Main Mode).
  * Various shortcuts are taken.  In particular, the policy, such as
  * it is, is hardwired.
@@ -677,6 +1412,12 @@
     struct isakmp_proposal proposal;
     unsigned no_trans_left;
     int last_transnum;
+    const struct connection *c = st->st_connection;
+    
+#ifdef OPENSSL
+    bool selected;
+    trans_list tl = NULL;
+#endif
 
     /* DOI */
     if (sa->isasa_doi != ISAKMP_DOI_IPSEC)
@@ -764,8 +1505,8 @@
 
     if (selection && proposal.isap_notrans != 1)
     {
-	loglog(RC_LOG_SERIOUS, "a single Transform is required in a selecting Oakley Proposal; found %u",
-	    (unsigned)proposal.isap_notrans);
+	loglog(RC_LOG_SERIOUS, "a single Transform is required in a selecting Oakley Proposal; found %u"
+	    , (unsigned)proposal.isap_notrans);
 	return BAD_PROPOSAL_SYNTAX;
     }
 
@@ -779,40 +1520,44 @@
 	u_char *attr_start;
 	size_t attr_len;
 	struct isakmp_transform trans;
-	lset_t
-	    seen_attrs = 0,
-	    seen_durations = 0;
+	lset_t seen_attrs = 0
+	    , seen_durations = 0;
 	u_int16_t life_type;
 	struct oakley_trans_attrs ta;
-	char ugh[100];	/* mailbox for diagnostics (arbitrary limit) */
+	char ugh[100];  /* mailbox for diagnostics (arbitrary limit) */
 
-	ugh[0] = '\0';	/* empty mailbox */
+	ugh[0] = '\0';  /* empty mailbox */
 
 	/* initialize only optional field in ta */
-	ta.life_seconds = OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT;	/* When this SA expires (seconds) */
+	/* When this SA expires (seconds) */
+	ta.life_seconds = OAKLEY_ISAKMP_SA_LIFETIME_DEFAULT;
 
 	if (no_trans_left == 0)
 	{
-	    loglog(RC_LOG_SERIOUS, "number of Transform Payloads disagrees with Oakley Proposal Payload");
-	    return BAD_PROPOSAL_SYNTAX;
+	  loglog(RC_LOG_SERIOUS, 
+	    "number of Transform Payloads disagrees with Oakley Proposal Payload");
+	  return BAD_PROPOSAL_SYNTAX;
 	}
 
-	if (!in_struct(&trans, &isakmp_isakmp_transform_desc, &proposal_pbs, &trans_pbs))
-	    return BAD_PROPOSAL_SYNTAX;
+	if (!in_struct(&trans, &isakmp_isakmp_transform_desc, 
+	  &proposal_pbs, &trans_pbs))
+	  return BAD_PROPOSAL_SYNTAX;
 
 	if (trans.isat_transnum <= last_transnum)
 	{
-	    /* picky, picky, picky */
-	    loglog(RC_LOG_SERIOUS, "Transform Numbers are not monotonically increasing"
-		" in Oakley Proposal");
-	    return BAD_PROPOSAL_SYNTAX;
+	  /* picky, picky, picky */
+	  loglog(RC_LOG_SERIOUS, 
+	    "Transform Numbers are not monotonically increasing"
+	    " in Oakley Proposal");
+	  return BAD_PROPOSAL_SYNTAX;
 	}
 	last_transnum = trans.isat_transnum;
 
 	if (trans.isat_transid != KEY_IKE)
 	{
-	    loglog(RC_LOG_SERIOUS, "expected KEY_IKE but found %s in Oakley Transform"
-		, enum_show(&isakmp_transformid_names, trans.isat_transid));
+	    loglog(RC_LOG_SERIOUS, 
+	      "expected KEY_IKE but found %s in Oakley Transform",
+	      enum_show(&isakmp_transformid_names, trans.isat_transid));
 	    return INVALID_TRANSFORM_ID;
 	}
 
@@ -820,7 +1565,6 @@
 	attr_len = pbs_left(&trans_pbs);
 
 	/* process all the attributes that make up the transform */
-
 	while (pbs_left(&trans_pbs) != 0)
 	{
 	    struct isakmp_attribute a;
@@ -828,16 +1572,18 @@
 	    enum_names *vdesc;
 	    u_int32_t val;	/* room for larger values */
 
-	    if (!in_struct(&a, &isakmp_oakley_attribute_desc, &trans_pbs, &attr_pbs))
-		return BAD_PROPOSAL_SYNTAX;
+	    if (!in_struct(&a, &isakmp_oakley_attribute_desc, 
+	      &trans_pbs, &attr_pbs))
+	      return BAD_PROPOSAL_SYNTAX;
 
 	    passert((a.isaat_af_type & ISAKMP_ATTR_RTYPE_MASK) < 32);
 
 	    if (seen_attrs & LELEM(a.isaat_af_type & ISAKMP_ATTR_RTYPE_MASK))
 	    {
-		loglog(RC_LOG_SERIOUS, "repeated %s attribute in Oakley Transform %u"
-		    , enum_show(&oakley_attr_names, a.isaat_af_type)
-		    , trans.isat_transnum);
+	      loglog(RC_LOG_SERIOUS, 
+	        "repeated %s attribute in Oakley Transform %u",
+	          enum_show(&oakley_attr_names, a.isaat_af_type),
+		    trans.isat_transnum);
 		return BAD_PROPOSAL_SYNTAX;
 	    }
 
@@ -854,10 +1600,10 @@
 			, (unsigned)val, enum_show(&oakley_attr_names, a.isaat_af_type));
 		    return ATTRIBUTES_NOT_SUPPORTED;
 		}
-		DBG(DBG_PARSING,
-		    if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
-			DBG_log("   [%u is %s]",
-			    (unsigned)val, enum_show(vdesc, val)));
+		DBG(DBG_PARSING
+		    , if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
+			DBG_log("   [%u is %s]"
+			    , (unsigned)val, enum_show(vdesc, val)));
 	    }
 
 	    switch (a.isaat_af_type)
@@ -865,12 +1611,25 @@
 		case OAKLEY_ENCRYPTION_ALGORITHM | ISAKMP_ATTR_AF_TV:
 		    switch (val)
 		    {
-#if 0	/* we don't feel DES is safe */
 		    case OAKLEY_DES_CBC:
-#endif
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES_BLOCK_CYPHER)) {
+			  ta.encrypt = val;
+			  ta.encrypter = &oakley_encrypter[val];
+			} else {
+			  snprintf(ugh, sizeof(ugh), "%s is not accepted",
+			    enum_show(&oakley_enc_names, val));
+			}
+			break;
 		    case OAKLEY_3DES_CBC:
-			ta.encrypt = val;
-			ta.encrypter = &oakley_encrypter[val];
+			if ((c->block_cypher == ALL_BLOCK_CYPHER) ||
+			  (c->block_cypher == DES3_BLOCK_CYPHER)) {
+			  ta.encrypt = val;
+			  ta.encrypter = &oakley_encrypter[val];
+			} else {
+			  snprintf(ugh, sizeof(ugh), "%s is not accepted",
+			    enum_show(&oakley_enc_names, val));
+			}
 			break;
 		    default:
 			snprintf(ugh, sizeof(ugh), "%s is not supported"
@@ -887,8 +1646,8 @@
 			ta.hasher = &oakley_hasher[val];
 			break;
 		    default:
-			snprintf(ugh, sizeof(ugh), "%s is not supported",
-			    enum_show(&oakley_hash_names, val));
+			snprintf(ugh, sizeof(ugh), "%s is not supported"
+			    , enum_show(&oakley_hash_names, val));
 		    }
 		    break;
 
@@ -896,27 +1655,65 @@
 		    switch (val)
 		    {
 		    case OAKLEY_PRESHARED_KEY:
-			/* Accept if policy specifies PSK or is default */
-			if ((st->st_policy & POLICY_PSK)
-			|| (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
+                        /* Accept if policy specifies PSK or is default */
+                        if (((st->st_policy & POLICY_PSK)
+                        || (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY))
 			{
-			    /* check that we can find a preshared secret */
-			    if (get_preshared_secret(st->st_connection) == NULL)
-				snprintf(ugh, sizeof(ugh)
-				    , "Can't authenticate: no preshared key");
-			    ta.auth = val;
+                            /* check that we can find a preshared secret */
+                            if (get_preshared_secret(st->st_connection) == NULL)
+                                snprintf(ugh, sizeof(ugh), "Can't authenticate: no preshared key");
+                            ta.auth = val;
 			}
 			else
 			{
-			    snprintf(ugh, sizeof(ugh)
-				, "policy does not allow OAKLEY_PRESHARED_KEY authentication");
+                          snprintf(ugh, sizeof(ugh), 
+                            "policy does not allow OAKLEY_PRESHARED_KEY authentication");
 			}
-			break;
+		        break;
 
-		    case OAKLEY_RSA_SIG:
-			/* Accept if policy specifies RSASIG or is default */
-			if ((st->st_policy & POLICY_RSASIG)
-			|| (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
+#ifdef OPENSSL
+                  case OAKLEY_DSS_SIG:
+                    if ((st->st_connection->key == NULL) ||
+                        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_DSA))
+                      snprintf(ugh, sizeof(ugh), "OAKLEY_DSS_SIG requested, but no DSA key available to sign with. Still unsupported.");
+                    ta.auth = val;
+                    break;
+/*
+ *                case OAKLEY_RSA_SIG:
+ * see after #endif OPENSSL
+ */
+                  case OAKLEY_RSA_ENC:
+                    if (!have_rsa_keypair(st))
+                      snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC:
+                    if (!have_elgamal_keypair(st))
+                      snprintf(ugh, sizeof(ugh), "OAKLEY_ELGAMAL_ENC requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_RSA_ENC_REV:
+                    if (!have_rsa_keypair(st))
+                      snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+                  case OAKLEY_ELGAMAL_ENC_REV:
+                    if (!have_elgamal_keypair(st))
+                      snprintf(ugh, sizeof(ugh), "OAKLEY_ELGAMAL_ENC_REV requested, but no cert available to encrypt with");
+                    ta.auth = val;
+                    break;
+
+		  case OAKLEY_RSA_SIG:
+		    if (!use_openssl(st->st_connection))
+		    {
+#endif /* OPENSSL, !use_openssl */
+		    /* Accept if policy specifies RSASIG or is default */
+#ifndef OPENSSL
+                       if ((st->st_policy & POLICY_RSASIG)
+#else
+                       if ((st->st_policy & POLICY_OPENSSL)
+#endif
+                       || (st->st_policy & POLICY_ISAKMP_MASK) == LEMPTY)
 			{
 			    /* We'd like to check that we can find a public
 			     * key for him and a private key for us that is
@@ -930,15 +1727,23 @@
 			}
 			else
 			{
-			    snprintf(ugh, sizeof(ugh)
-				, "policy does not allow OAKLEY_RSA_SIG authentication");
+                          snprintf(ugh, sizeof(ugh)
+                              , "policy does not allow OAKLEY_RSA_SIG authentication");
 			}
-			break;
+#ifdef OPENSSL
+		    } else { /* use_openssl */
+		      if ((st->st_connection->key == NULL) ||
+		        (((EVP_PKEY *)(st->st_connection->key))->type != EVP_PKEY_RSA))
+		        snprintf(ugh, sizeof(ugh), "OAKLEY_RSA_SIG requested, but no key available to sign with");
+		      ta.auth = val;
+		    }
+#endif
+                    break;
 
 		    default:
-			snprintf(ugh, sizeof(ugh)
-			    , "Pluto does not support %s authentication"
-			    , enum_show(&oakley_auth_names, val));
+			snprintf(ugh, sizeof(ugh), 
+			  "Pluto does not support %s authentication", 
+			  enum_show(&oakley_auth_names, val));
 			break;
 		    }
 		    break;
@@ -947,7 +1752,8 @@
 		    ta.group = lookup_group(val);
 		    if (ta.group == NULL)
 		    {
-			snprintf(ugh, sizeof(ugh), "only OAKLEY_GROUP_MODP1024 and OAKLEY_GROUP_MODP1536 supported");
+			snprintf(ugh, sizeof(ugh), 
+		          "only OAKLEY_GROUP_MODP1024 and OAKLEY_GROUP_MODP1536 supported");
 			break;
 		    }
 		    break;
@@ -969,8 +1775,8 @@
 		case OAKLEY_LIFE_DURATION | ISAKMP_ATTR_AF_TV:
 		    if ((seen_attrs & LELEM(OAKLEY_LIFE_TYPE)) == 0)
 		    {
-			snprintf(ugh, sizeof(ugh),
-			    "OAKLEY_LIFE_DURATION attribute not preceded by OAKLEY_LIFE_TYPE attribute");
+			snprintf(ugh, sizeof(ugh), 
+		          "OAKLEY_LIFE_DURATION attribute not preceded by OAKLEY_LIFE_TYPE attribute");
 			break;
 		    }
 		    seen_attrs &= ~(LELEM(OAKLEY_LIFE_DURATION) | LELEM(OAKLEY_LIFE_TYPE));
@@ -979,7 +1785,7 @@
 		    {
 			case OAKLEY_LIFE_SECONDS:
 			    if (val > OAKLEY_ISAKMP_SA_LIFETIME_MAXIMUM)
-				snprintf(ugh, sizeof(ugh),
+				snprintf(ugh, sizeof(ugh), 
 				    "peer requested %lu seconds"
 				    " which exceeds our limit %d seconds"
 				    , (long) val
@@ -1016,7 +1822,7 @@
 		default:
 		    snprintf(ugh, sizeof(ugh), "unsupported OAKLEY attribute");
 		    break;
-	    }
+	    }   /* switch (a.isaat_af_type) */
 
 	    if (ugh[0] != '\0')
 	    {
@@ -1024,7 +1830,7 @@
 		    , ugh, enum_show(&oakley_attr_names, a.isaat_af_type));
 		break;
 	    }
-	}
+	} /* while (pbs_left(&trans_pbs) != 0) */
 
 	if (ugh[0] == '\0')
 	{
@@ -1049,8 +1855,9 @@
 	     * Lets finish early and leave.
 	     */
 
-	    DBG(DBG_PARSING | DBG_CRYPT,
-		DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
+#ifndef OPENSSL
+	    DBG(DBG_PARSING | DBG_CRYPT
+		, DBG_log("Oakley Transform %u accepted", trans.isat_transnum));
 
 	    if (r_sa_pbs != NULL)
 	    {
@@ -1084,15 +1891,16 @@
 
 		/* Transform */
 		r_trans.isat_np = ISAKMP_NEXT_NONE;
-		if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, &r_proposal_pbs, &r_trans_pbs))
-		    passert(FALSE);
+		if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, 
+	          &r_proposal_pbs, &r_trans_pbs))
+		  passert(FALSE);
 
 		if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
 		    passert(FALSE);
 		close_output_pbs(&r_trans_pbs);
 		close_output_pbs(&r_proposal_pbs);
 		close_output_pbs(r_sa_pbs);
-	    }
+	    }     /* if (r_sa_pbs != NULL) */
 
 	    /* ??? If selection, we used to save the proposal in state.
 	     * We never used it.  From proposal_pbs.start,
@@ -1102,7 +1910,15 @@
 	    /* copy over the results */
 	    st->st_oakley = ta;
 	    return NOTHING_WRONG;
-	}
+#else
+	    /*
+	     * We store the ta result into the list of candidates
+	     * Afterwards, site policy dictates which of the
+	     * candidates we should select
+	     */
+	    trans_list_append(&tl, &ta, &trans, attr_start, attr_len);
+#endif
+	} /* if (ugh == '\0') */
 
 	/* on to next transform */
 	no_trans_left--;
@@ -1111,20 +1927,90 @@
 	{
 	    if (no_trans_left != 0)
 	    {
-		loglog(RC_LOG_SERIOUS, "number of Transform Payloads disagrees with Oakley Proposal Payload");
+		loglog(RC_LOG_SERIOUS, 
+	          "number of Transform Payloads disagrees with Oakley Proposal Payload");
 		return BAD_PROPOSAL_SYNTAX;
 	    }
 	    break;
 	}
+
 	if (trans.isat_np != ISAKMP_NEXT_T)
 	{
 	    loglog(RC_LOG_SERIOUS, "unexpected %s payload in Oakley Proposal"
 		, enum_show(&payload_names, proposal.isap_np));
 	    return BAD_PROPOSAL_SYNTAX;
 	}
-    }
+    } /* for */
+
+#ifndef OPENSSL
     loglog(RC_LOG_SERIOUS, "no acceptable Oakley Transform");
     return NO_PROPOSAL_CHOSEN;
+#else
+    /* We should have a list of hopefuls in the list tl */
+    { /* open scope */
+      u_char *attr_start;
+      size_t attr_len;
+      struct isakmp_transform trans;
+
+      selected = select_trans_candidate(tl, &st->st_oakley, &trans, 
+        &attr_start, &attr_len, st->st_connection->cert_options);
+      trans_list_free(&tl);
+      if (! selected) {
+        log("no acceptable Oakley Transform");
+        return NO_PROPOSAL_CHOSEN;
+      } else {
+        DBG(DBG_PARSING | DBG_CRYPT,
+        DBG_log("Oakley Transform %u accepted", trans.isat_transnum)
+        );
+
+        if (r_sa_pbs != NULL)
+        {
+          struct isakmp_proposal r_proposal = proposal;
+          pb_stream r_proposal_pbs;
+          struct isakmp_transform r_trans = trans;
+          pb_stream r_trans_pbs;
+
+          /* Situation */
+          if (!out_struct(&ipsecdoisit, &ipsec_sit_desc, r_sa_pbs, NULL))
+            passert(FALSE);
+
+          /* Proposal */
+#ifdef EMIT_ISAKMP_SPI
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          r_proposal.isap_spisize = 0;
+#endif
+          r_proposal.isap_notrans = 1;
+          if (!out_struct(&r_proposal, &isakmp_proposal_desc, r_sa_pbs, &r_proposal_pbs))
+            passert(FALSE);
+
+          /* SPI */
+#ifdef EMIT_ISAKMP_SPI
+          if (!out_raw(my_cookie, COOKIE_SIZE, &r_proposal_pbs, "SPI"))
+            passert(FALSE);
+          r_proposal.isap_spisize = COOKIE_SIZE;
+#else
+          /* none (0) */
+#endif
+
+          /* Transform */
+          r_trans.isat_np = ISAKMP_NEXT_NONE;
+          if (!out_struct(&r_trans, &isakmp_isakmp_transform_desc, 
+            &r_proposal_pbs, &r_trans_pbs))
+            passert(FALSE);
+
+          if (!out_raw(attr_start, attr_len, &r_trans_pbs, "attributes"))
+            passert(FALSE);
+          if (attr_start) pfree(attr_start);
+
+          close_output_pbs(&r_trans_pbs);
+          close_output_pbs(&r_proposal_pbs);
+          close_output_pbs(r_sa_pbs);
+        }     /* if (r_sa_pbs != NULL) */
+      return NOTHING_WRONG;
+      }       /* if (! selected) */
+    }  /* end this scope */
+#endif        /* OPENSSL */
 }
 
 /* Parse the body of an IPsec SA Payload (i.e. Phase 2 / Quick Mode).
@@ -1164,18 +2050,19 @@
 };
 
 static bool
-parse_ipsec_transform(struct isakmp_transform *trans
-, struct ipsec_trans_attrs *attrs
-, pb_stream *prop_pbs
-, pb_stream *trans_pbs
-, struct_desc *trans_desc
-, int previous_transnum	/* or -1 if none */
-, bool selection
-, bool is_last
-, bool is_ipcomp
-, struct state *st)	/* current state object */
+parse_ipsec_transform(
+    struct isakmp_transform *trans,
+    struct ipsec_trans_attrs *attrs,
+    pb_stream *prop_pbs,
+    pb_stream *trans_pbs,
+    struct_desc *trans_desc,
+    int previous_transnum,	/* or -1 if none */
+    bool selection,
+    bool is_last,
+    bool is_ipcomp,
+    struct state *st)	/* current state object */
 {
-    lset_t
+    lset_t 
 	seen_attrs = 0,
 	seen_durations = 0;
     u_int16_t life_type;
@@ -1249,10 +2136,10 @@
 		    , (unsigned)val, enum_show(&ipsec_attr_names, a.isaat_af_type));
 		return FALSE;
 	    }
-	    DBG(DBG_PARSING,
-		if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
-		    DBG_log("   [%u is %s]",
-			(unsigned)val, enum_show(vdesc, val)));
+	    DBG(DBG_PARSING
+		, if ((a.isaat_af_type & ISAKMP_ATTR_AF_MASK) == ISAKMP_ATTR_AF_TV)
+		    DBG_log("   [%u is %s]"
+			, (unsigned)val, enum_show(vdesc, val)));
 	}
 
 	switch (a.isaat_af_type)
@@ -1553,7 +2440,7 @@
 		/* We store CPI in the low order of a network order
 		 * ipsec_spi_t.  So we start a couple of bytes in.
 		 */
-		memset(&next_spi, '\0', sizeof(next_spi));
+                memset(&next_spi, '\0', sizeof(next_spi));
 		if (!in_raw((u_char *)&next_spi
 		  + IPSEC_DOI_SPI_SIZE - IPCOMP_CPI_SIZE
 		, IPCOMP_CPI_SIZE, &next_proposal_pbs, "CPI"))
@@ -1759,8 +2646,8 @@
 		}
 		if (!ok_auth)
 		{
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("%s attribute unsupported"
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("%s attribute unsupported"
 			    " in %s Transform from %s"
 			    , enum_name(&auth_alg_names, ah_attrs.auth)
 			    , enum_show(&ah_transformid_names, ah_attrs.transid)
@@ -1797,9 +2684,7 @@
 
 		switch (esp_attrs.transid)
 		{
-#if 0	/* we don't feel single DES is safe */
 		    case ESP_DES:
-#endif
 		    case ESP_3DES:
 			break;
 
@@ -1812,8 +2697,8 @@
 			}
 			if (st->st_policy & POLICY_ENCRYPT)
 			{
-			    DBG(DBG_CONTROL | DBG_CRYPT,
-				    DBG_log("ESP_NULL Transform Proposal from %s"
+			    DBG(DBG_CONTROL | DBG_CRYPT
+				    , DBG_log("ESP_NULL Transform Proposal from %s"
 					" does not satisfy POLICY_ENCRYPT"
 					, ip_str(&c->that.host_addr)));
 			    continue;   /* try another */
@@ -1854,8 +2739,8 @@
 		if (ah_seen && ah_attrs.encapsulation != esp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("AH and ESP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("AH and ESP transforms disagree about encapsulation; TUNNEL presumed"));
 		}
 
 		break;	/* we seem to be happy */
@@ -1946,13 +2831,13 @@
 		if (ah_seen && ah_attrs.encapsulation != ipcomp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("AH and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("AH and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
 		} else if (esp_seen && esp_attrs.encapsulation != ipcomp_attrs.encapsulation)
 		{
 		    /* ??? This should be an error, but is it? */
-		    DBG(DBG_CONTROL | DBG_CRYPT,
-			DBG_log("ESP and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
+		    DBG(DBG_CONTROL | DBG_CRYPT
+			, DBG_log("ESP and IPCOMP transforms disagree about encapsulation; TUNNEL presumed"));
 		}
 
 		break;	/* we seem to be happy */
@@ -1974,33 +2859,33 @@
 
 	    /* AH proposal */
 	    if (ah_seen)
-		echo_proposal(ah_proposal,
-		    ah_trans,
-		    esp_seen || ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_ah,
-		    &isakmp_ah_transform_desc,
-		    &ah_trans_pbs);
+		echo_proposal(ah_proposal
+		    , ah_trans
+		    , esp_seen || ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_ah
+		    , &isakmp_ah_transform_desc
+		    , &ah_trans_pbs);
 
 	    /* ESP proposal */
 	    if (esp_seen)
-		echo_proposal(esp_proposal,
-		    esp_trans,
-		    ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_esp,
-		    &isakmp_esp_transform_desc,
-		    &esp_trans_pbs);
+		echo_proposal(esp_proposal
+		    , esp_trans
+		    , ipcomp_seen? ISAKMP_NEXT_P : ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_esp
+		    , &isakmp_esp_transform_desc
+		    , &esp_trans_pbs);
 
 	    /* IPCOMP proposal */
 	    if (ipcomp_seen)
-		echo_proposal(ipcomp_proposal,
-		    ipcomp_trans,
-		    ISAKMP_NEXT_NONE,
-		    r_sa_pbs,
-		    &st->st_ipcomp,
-		    &isakmp_ipcomp_transform_desc,
-		    &ipcomp_trans_pbs);
+		echo_proposal(ipcomp_proposal
+		    , ipcomp_trans
+		    , ISAKMP_NEXT_NONE
+		    , r_sa_pbs
+		    , &st->st_ipcomp
+		    , &isakmp_ipcomp_transform_desc
+		    , &ipcomp_trans_pbs);
 
 	    close_output_pbs(r_sa_pbs);
 	}
diff -ruN freeswan-1.9.orig/pluto/spdb.h freeswan-1.9/pluto/spdb.h
--- freeswan-1.9.orig/pluto/spdb.h	Fri Sep 15 05:09:28 2000
+++ freeswan-1.9/pluto/spdb.h	Wed May 16 10:57:20 2001
@@ -24,11 +24,32 @@
     u_int16_t val;
 };
 
+#ifdef OPENSSL
+typedef bool offer_fn(struct state *st);
+/* Addition for OpenSSL: we don't want to offer cipher suites */
+/* which we aren't capable of generating, so I added a function */
+/* parameter 'offer', which takes the state as a parameter, and */
+/* returns either TRUE or FALSE, depending on whether the cipher */
+/* suite is supportable. For instance, there's no point in */
+/* offering to sign things with a DSA signature key, if all you've */
+/* got is an RSA one. */
+/* NB: If the function pointer is set to NULL, it means offer the */
+/* cipher suite under all conditions. The downside to this is that */
+/* another parameter must be added to all the IPsec cipher transforms */
+/* which is always NULL. I suppose we could embed policy information */
+/* within that parameter, e.g. If a pair of endpoints must have */
+/* a particular cipher between them. Trouble is, that information is */
+/* present within ipsec.conf, to some extent -- nd */
+#endif
+
 /* transform */
 struct db_trans {
     u_int8_t transid;	/* Transform-Id */
     struct db_attr *attrs;	/* array */
     int attr_cnt;	/* number of elements */
+#ifdef OPENSSL
+    offer_fn *offer;
+#endif
 };
 
 /* proposal */
@@ -56,9 +77,12 @@
 };
 
 /* The oakley sadb is subscripted by a bitset with members
- * from POLICY_PSK and POLICY_RSASIG.
+ * from POLICY_PSK and POLICY_RSASIG/OPENSSL.
  */
 extern struct db_sa oakley_sadb[1 << 2];
+#ifdef OPENSSL
+extern struct db_sa oakley_sadb2[1 << 2];
+#endif
 
 /* The ipsec sadb is subscripted by a bitset with members
  * from POLICY_ENCRYPT, POLICY_AUTHENTICATE, POLICY_COMPRESS
diff -ruN freeswan-1.9.orig/pluto/state.c freeswan-1.9/pluto/state.c
--- freeswan-1.9.orig/pluto/state.c	Tue Jan 30 16:58:36 2001
+++ freeswan-1.9/pluto/state.c	Wed May 16 10:57:20 2001
@@ -348,6 +348,16 @@
     pfreeany(st->st_esp.our_keymat);
     pfreeany(st->st_esp.peer_keymat);
 
+#ifdef OPENSSL
+    /* Clean out the stuff for revised PK encryption mode */
+    pfreeany(st->st_ne_i.ptr);
+    memset(&st->st_ks_i, 0, sizeof(st->st_ks_i));
+    memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+    pfreeany(st->st_ne_r.ptr);
+    memset(&st->st_ks_r, 0, sizeof(st->st_ks_r));
+    memset(st->st_ne_r_iv, 0, MAX_DIGEST_LEN);
+#endif
+
     pfree(st);
 }
 
diff -ruN freeswan-1.9.orig/pluto/state.h freeswan-1.9/pluto/state.h
--- freeswan-1.9.orig/pluto/state.h	Tue Jan 30 16:58:36 2001
+++ freeswan-1.9/pluto/state.h	Wed May 16 10:57:20 2001
@@ -146,6 +146,15 @@
     u_int8_t           st_rcookie[COOKIE_SIZE];/* Responder Cookie */
     chunk_t            st_nr;                  /* Nr nonce */
 
+#ifdef OPENSSL
+    /* key material for revised public key information */
+    u_int8_t           st_ne_i_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_i;                /* key for initiator payloads */
+    keysched           st_ks_i;
+    u_int8_t           st_ne_r_iv[MAX_DIGEST_LEN];
+    chunk_t            st_ne_r;                /* key for responder payloads */
+    keysched           st_ks_r;
+#endif
 
   /* my stuff */
 
diff -ruN freeswan-1.9.orig/pluto/version.c freeswan-1.9/pluto/version.c
--- freeswan-1.9.orig/pluto/version.c	Mon Feb 26 18:56:08 2001
+++ freeswan-1.9/pluto/version.c	Thu May 17 14:34:39 2001
@@ -1,2 +1,2 @@
-/* silly pointless RCSID $Id: version.c,v 1.17.2.1 2001/02/26 23:56:08 henry Exp $ */
-static const char freeswan_version[] = "1.9";
+/* silly pointless RCSID $Id: version.c,v 1.17 2000/11/30 05:02:51 henry Exp $ */
+static const char freeswan_version[] = "FreeSWAN-1.9-pkix1";
